// Code generated by go-swagger; DO NOT EDIT.

package other

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewJqPlaygroundParams creates a new JqPlaygroundParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewJqPlaygroundParams() *JqPlaygroundParams {
	return &JqPlaygroundParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewJqPlaygroundParamsWithTimeout creates a new JqPlaygroundParams object
// with the ability to set a timeout on a request.
func NewJqPlaygroundParamsWithTimeout(timeout time.Duration) *JqPlaygroundParams {
	return &JqPlaygroundParams{
		timeout: timeout,
	}
}

// NewJqPlaygroundParamsWithContext creates a new JqPlaygroundParams object
// with the ability to set a context for a request.
func NewJqPlaygroundParamsWithContext(ctx context.Context) *JqPlaygroundParams {
	return &JqPlaygroundParams{
		Context: ctx,
	}
}

// NewJqPlaygroundParamsWithHTTPClient creates a new JqPlaygroundParams object
// with the ability to set a custom HTTPClient for a request.
func NewJqPlaygroundParamsWithHTTPClient(client *http.Client) *JqPlaygroundParams {
	return &JqPlaygroundParams{
		HTTPClient: client,
	}
}

/* JqPlaygroundParams contains all the parameters to send to the API endpoint
   for the jq playground operation.

   Typically these are written to a http.Request.
*/
type JqPlaygroundParams struct {

	/* JQPayload.

	   Payload that contains both the JSON data to manipulate and jq query.
	*/
	JQPayload JqPlaygroundBody

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the jq playground params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *JqPlaygroundParams) WithDefaults() *JqPlaygroundParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the jq playground params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *JqPlaygroundParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the jq playground params
func (o *JqPlaygroundParams) WithTimeout(timeout time.Duration) *JqPlaygroundParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the jq playground params
func (o *JqPlaygroundParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the jq playground params
func (o *JqPlaygroundParams) WithContext(ctx context.Context) *JqPlaygroundParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the jq playground params
func (o *JqPlaygroundParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the jq playground params
func (o *JqPlaygroundParams) WithHTTPClient(client *http.Client) *JqPlaygroundParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the jq playground params
func (o *JqPlaygroundParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithJQPayload adds the jQPayload to the jq playground params
func (o *JqPlaygroundParams) WithJQPayload(jQPayload JqPlaygroundBody) *JqPlaygroundParams {
	o.SetJQPayload(jQPayload)
	return o
}

// SetJQPayload adds the jQPayload to the jq playground params
func (o *JqPlaygroundParams) SetJQPayload(jQPayload JqPlaygroundBody) {
	o.JQPayload = jQPayload
}

// WriteToRequest writes these params to a swagger request
func (o *JqPlaygroundParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if err := r.SetBodyParam(o.JQPayload); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
